// =========================================================
// Рисование растровых изображений с ожиданием их загрузки
//
// (C) Фролов А.В, 1997
//
// E-mail: frolov@glas.apc.org
// WWW:    http://www.glasnet.ru/~frolov
//            или
//         http://www.dials.ccas.ru/frolov
// =========================================================
import java.applet.*;
import java.awt.*;

public class ImageDrawWait extends Applet
{
  // Фоновое изображение
  Image BkgImg;
  
  // Изображение флоппи-диска
  Image FloppyDiskImg;

  // Изображение компакт-диска
  Image CDDiskImg;

  // Ссылка на MediaTracker
  MediaTracker mt;

	// -------------------------------------------------------
  // getAppletInfo
  // Метод, возвращающей строку информации об аплете
  // -------------------------------------------------------
	public String getAppletInfo()
	{
		return "Name: ImageDrawWait\r\n" +
      "Author: Alexandr Frolov\r\n" +
      "E-mail: frolov@glas.apc.org" +
      "WWW:    http://www.glasnet.ru/~frolov" +
      "Created with Microsoft Visual J++ Version 1.0";
	}


  // -------------------------------------------------------
  // init
  // Метод init, получает управление при инициализации аплета
  // -------------------------------------------------------
	public void init()
	{
    // Создаем объект класса MediaTracker
    mt = new MediaTracker(this);

    // Загружаем фоновое изображение
    BkgImg = getImage(getCodeBase(), "bkg.gif");
    
    // Добавляем его в список объекта MediaTracker
    mt.addImage(BkgImg , 0);

    // Загружаем изображение флоппи-диска
    FloppyDiskImg = getImage(getCodeBase(), "disk.gif");

    // Добавляем его в список объекта MediaTracker
    mt.addImage(FloppyDiskImg, 0);

    // Загружаем изображение флоппи-диска
    CDDiskImg = getImage(getCodeBase(), "cd.gif");

    // Добавляем его в список объекта MediaTracker
    mt.addImage(CDDiskImg, 0);
	}

  // -------------------------------------------------------
  // paint
  // Метод paint, выполняющий рисование в окне аплета
  // -------------------------------------------------------
	public void paint(Graphics g)
	{
    // Определяем текущие размеры окна аплета
    Dimension dimAppWndDimension = size();
    
    // Выбираем в контекст отображения белый цвет
    g.setColor(Color.white);
    
    // Закрашиваем внутреннюю область окна аплета
    g.fillRect(0, 0, 
      dimAppWndDimension.width  - 1, 
      dimAppWndDimension.height - 1);

    // Выбираем в контекст отображения черный цвет
    g.setColor(Color.black);

    // Рисуем рамку вокруг окна аплета
    g.drawRect(0, 0, 
      dimAppWndDimension.width  - 1, 
      dimAppWndDimension.height - 1);

    // Рисуем сообщение о начале загрузки
    g.drawString("Подождите, идет загрузка...",
      20, dimAppWndDimension.height / 2);

    // Ждем, пока все изображения не будут загружены
    try
    {
      mt.waitForAll();
    }
    catch (InterruptedException ex)
    {
    }

    // Рисуем изображение фона
    g.drawImage(BkgImg, 1, 1, 
      dimAppWndDimension.width  - 2, 
      dimAppWndDimension.height - 2, this);

    // Рисуем увеличенное изображение флоппи-диска
    g.drawImage(FloppyDiskImg, 25, 42, 200, 200, this);

    // Рисуем нормальное изображение флоппи-диска
    g.drawImage(FloppyDiskImg, 25, 3, this);

    // Рисуем нормальное изображение компакт-диска
    g.drawImage(CDDiskImg , 70, 3, this);

    // Рисуем вытянутое изображение компакт-диска
    g.drawImage(CDDiskImg , 115, 3, 40, 25, this);
	}
}
